"""
James W. Rohlf
Clone of the C++ AMC13Tool
05/27/2012
"""

from flashlib_v20 import *
import os
import sys
import string


fdi={}
for dirname, dirnames, filenames in os.walk('../firmware_amc13'):
    i=0
    for filename in filenames:
        #print os.path.join(dirname,filename)
        fdi[i]=filename
        i +=1
#print "The following firmware files were found in firmware_amc13:"
nf=len(fdi)
#for i in xrange(nf): print i, fdi[i]
#print fdi
#open(s,'r')

n=len(fdi)
type={}
for i in xrange(n):
    type[i]='unknown'
    if 'T1' in fdi[i]:
        #print "found T1", fdi[i]
        type[i]='Virtex'
    if 'T2' in fdi[i] and not 'Header' in fdi[i] and not 'Golden' in fdi[i]:
        #print "found T2", fdi[i]
        type[i]='Spartan'
    if 'Header' in fdi[i]:
        type[i]='Header'
    if 'Golden' in fdi[i]:
        type[i]='Golden'
#print type

lengths={}
pad={}
#print "The following firmware files were found in firmware_amc13:"
nf=len(fdi)
for i in xrange(nf):
    lengths[i] = len(fdi[i])
#maxlen = max(lengths)
#for i in xrange(nf):
#    print i, fdi[i], " "*(20 - lengths[i] + 1), type[i]


amc13.spartan=t2
amc13.virtex=t1
t1, t2 = amc13.connect(sn)
amc13x = t2
iloop=1000
while iloop!=0:
    print "type h for menu"
    option = raw_input(">")
    input=option.split()
    #print input
    if option =="h" or option =="help" or option =="ls":
        print "  (.)q quit"
        print "    fv get firmware version"
        print "     i init (reset spartan and virtex and enable TTC)"
        print "   res reset spartan"
        print "   rev reset virtex"
        print "     v virtex voltages" 
        print "     t virtex die temperature"
        print "__________________________________________________________________" 
        print "   enT enable TTC" 
        print "   erT TTC error counts" 
        print " s(v)T n -> read spartan (virtex) TTC n times" 
        print "__________________________________________________________________" 
        print "ras(v) read all spartan (virtex) registers"
        print " rs(v) add n      -> single read spartan (virtex) n words from add" 
        print "rrs(v)            -> read spartan (virtex) by register name"
        print " ws(v) add n      -> single write spartan (virtex) n words from add" 
        print "brs(v) add n      -> block read spartan (virtex) n words from add" 
        print "frs(v) add n      -> read spartan (virtex) fifo"
        print "wrs(v)            -> write spartan (virtex) by register name"
        print "bws(v) add data n -> block write spartan (virtex) "
        print "qws(v) add data n -> queued write spartan (virtex) data"
        print "fws(v) add data n -> write spartan (virtex) fifo"
        print "__________________________________________________________________" 
        print "    rf add -> read 256 bytes from flash at add" 
        print "   vfh verify flash header" 
        print " vs(v) verify spartan (virtex) flash" 
        print "   vbs verify spartan backup flash" 
        print "   PFH program flash header" 
        print " PS(V) program spartan (virtex) flash" 
        print "   PBS program spartan backup flash" 
        print "     L load (both spartan and virtex) firmware from flash"

    if option =="fv":
        z=t2.read("ID",0x0)
        sn=(z & 0xff)
        print "spartan firmware version = ", sn
        z=t1.read("ID",0x0)
        sn=(z & 0xff)
        print " virtex firmware version = ", sn
    if option =="q":
        iloop=0
    if option =="i":
        t1.write("CONTROL0", 0x1);
        t2.write("CONTROL0", 0x1);
        t2.write("TTC_ENABLE", 0xfff);
        print "*** amc13 has been initialized ***"
    if option =="res":
        t2.write("CONTROL0", 0x1);
        print "*** spartan has been issued a reset ***"
    if option =="rev":
        t1.write("CONTROL0", 0x1);
        print "*** spartan has been issued a reset ***"

    if option =="v":
        print "reading virtex voltages:"
        volt=float(t1.read("1.0V_PWR"))/1000.
        print "1.0V_PWR   ", volt, " V"
        volt=float(t1.read("2.5V_PWR"))/1000.
        print "2.5V_PWR   ", volt, " V"
    if option =="t":
        print "reading virtex die temp:"
        temp=float(t1.read("V6_DIE_TEMP"))/1000.
        print "V6 DIE TEMP   ", temp, " C"
    if option =="enT":
        t2.write("TTC_ENABLE", 0xfff);
        print "*** TTC has been enabled ***"
    if option =="erT":
        print "\nTTC error counts:\n"
        print "          single    multi    bunch"
        s = t2.read("TTC_SBERROR");
        m = t2.read("TTC_MBERROR");
        b = t2.read("TTC_BCERROR");
        print "spartan %08x" % s,"%08x" % m,"%08x" % b
        s = t1.read("TTC_SBERROR");
        m = t1.read("TTC_MBERROR");
        b = t1.read("TTC_BCERROR");
        print " virtex %08x" % s,"%08x" % m,"%08x" % b
    if input[0] =="sT":
        n=1
        if (len(input) > 1): n=int(input[1])
        print "\nTTC data from Spartan:\n"
        print "           bunch    event    orbit"
        for i in xrange(n):     
             b = t2.read("TTC_BCN");
             e = t2.read("TTC_EVN");
             o = t2.read("TTC_ORN");
             print "        %08x" % b,"%08x" % e,"%08x" % o
    if input[0] =="vT":
        n=1
        if (len(input) > 1): n=int(input[1])
        print "\nTTC data from Virtex:\n"
        print "           bunch    event    orbit"
        for i in xrange(n):     
             b = t1.read("TTC_BCN");
             e = t1.read("TTC_EVN");
             o = t1.read("TTC_ORN");
             print "        %08x" % b,"%08x" % e,"%08x" % o
#read/write section 
    if input[0] =="ras" or input[0]=="rav":
        if input[0] =="ras": f = open('../addresstables_amc13/AMC13_AddressTable_S6_v01.txt', 'r')
        if input[0] =="rav": f = open('../addresstables_amc13/AMC13_AddressTable_V6_v01.txt', 'r')
        whole=f.read()
        linelist = whole.split("\n")
        nlines=len(linelist)
        str=[]
#loop over lines in address table
        for line in linelist:
            length =len(line)
            list=line.split()
    #ifgore comment lines and blank lines
            if length !=0 and line[0] != '*':
        #use only read enabled registers
                if list[3]=='1':
                    if input[0] =="ras": print "%012s" % list[0], "    %08x" % t2.read(list[0])
                    if input[0] =="rav": print "%019s" % list[0], "    %08x" % t1.read(list[0])
    if input[0] =="rs" or input[0]=="rv":
        amc13x=t2
        if input[0]=="rv": amc13x=t1
        add=0
        if( len(input) > 1): add=int(input[1],16)
        n=1
        if (len(input) > 2): n=int(input[2],16)
        if input[0]=="rs": print "reading from spartan:"
        if input[0]=="rv": print "reading from virtex:"
        for iii in xrange(n):
            data=amc13x.read("ID",add)
            print "        %08x" % add,"%08x" % data
            add +=1
    if input[0]=="frs" or input[0] =="frv":
        amc13x=t2
        if input[0]=="frv": amc13x=t1
        add=0
        if( len(input) > 1): add=int(input[1],16)
        n=1
        if (len(input) > 2): n=int(input[2],16)
        if input=="frs": print "fifo read from spartan:"
        if input=="frv": print "fifo read from virtex:"
        for iii in xrange(n):
             data=amc13x.read("ID",add)
             print "        %08x" % add,"%08x" % data
    if input[0] =="rrs":
        print "enter register name:"
        regName=raw_input(">")
        data=t2.read(regName)
        print regName,"%08x" % data
    if input[0] =="rrv":
        print "enter register name:"
        regName=raw_input(">")
        data=t1.read(regName)
        print regName,"%08x" % data
    if input[0] =="wrs":
        print "enter register, data:"
        option2=raw_input(">")
        secondInput=option2.split()
        regName=secondInput[0]
        dataOut=int(secondInput[1],16)
        t2.write(regName,dataOut)
    if input[0] =="wrv":
        print "enter register, data:"
        option2=raw_input(">")
        secondInput=option2.split()
        regName=secondInput[0]
        dataOut=secondInput[1]
        t1.write(regName,dataOut)
    if input[0] =="ws" or input[0]=="wv":
        amc13x=t2
        if input[0]=="rv": amc13x=t1
        add=0
        if( len(input) > 1): add=int(input[1],16)
        data=0
        print data
        if( len(input) > 2): data=int(input[2],16)
        n=1
        if (len(input) > 3): n=int(input[3],16)
        if input[0] =="ws": print "writing to spartan:"
        if input[0] =="wv": print "writing to virtex:"
        for iii in xrange(n):
            amc13x.write("ID",data,add)
            print "        %08x" % add,"%08x" % data
            add +=1
            data +=1
    if input[0] =="qws" or input[0]=="qwv":
        amc13x=t2
        if input[0]=="qrv": amc13x=t1
        add=0
        if( len(input) > 1): add=int(input[1],16)
        data=0
        print data
        if( len(input) > 2): data=int(input[2],16)
        n=1
        if (len(input) > 3): n=int(input[3],16)
        if input[0] =="qws": print "queue write to spartan:"
        if input[0] =="qwv": print "queue write to virtex:"
        for iii in xrange(n):
            amc13x.queueWrite("ID",data,add)
            print "        %08x" % add,"%08x" % data
            add +=1
            data +=1
        amc13x.queueRun()
    if input[0] =="fws":
        add=0
        if( len(input) > 1): add=int(input[1],16)
        data=0
        print data
        if( len(input) > 2): data=int(input[2],16)
        n=1
        if (len(input) > 3): n=int(input[3],16)
        print "writing to spartan:"
        for iii in xrange(n):
            t2.write("ID",data,add)
            print "        %08x" % add,"%08x" % data
            data +=1
    if input[0] =="fwv":
        add=0
        if( len(input) > 1): add=int(input[1],16)
        data=0
        print data
        if( len(input) > 2): data=int(input[2],16)
        n=1
        if (len(input) > 3): n=int(input[3],16)
        print "writing to spartan:"
        for iii in xrange(n):
            t1.write("ID",data,add)
            print "        %08x" % add,"%08x" % data
            data +=1
    if input[0] =="brs":
        add=0
        if( len(input) > 1): add=int(input[1],16)
        n=1
        if (len(input) > 2): n=int(input[2],16)
        print "reading from spartan:"
        data=t2.blockRead("ID",n,add)
        for iii in xrange(n):
            print "        %08x" % add,"%08x" % data[iii]
            iii +=1
            add +=1
    if input[0] =="brv":
        add=0
        if( len(input) > 1): add=int(input[1],16)
        n=1
        if (len(input) > 2): n=int(input[2],16)
        print "reading from virtex:"
        data=t1.blockRead("ID",n,add)
        for iii in xrange(n):
            print "        %08x" % add,"%08x" % data[iii]
            iii +=1
            add +=1
    if input[0] =="bws":
        add=0
        if( len(input) > 1): add=int(input[1],16)
        dataStart=0
        if (len(input) > 2): dataStart=int(input[2],16)
        n=1
        if (len(input) > 3): n=int(input[3],16)
        dataout=[]
        for jjj in xrange(n): dataout.append(jjj+dataStart)
        print "block writing to spartan:"
        #print dataout
        t2.blockWrite("ID",dataout,add)
    if input[0] =="bwv":
        add=0
        if( len(input) > 1): add=int(input[1],16)
        dataStart=0
        if (len(input) > 2): dataStart=int(input[2],16)
        n=1
        if (len(input) > 3): n=int(input[3],16)
        dataout=[]
        for jjj in xrange(n): dataout.append(jjj+dataStart)
        print "block writing to virtex:"
        #print dataout
        t1.blockWrite("ID",dataout,add)
#program/verify flash section 
    enter=0
    if (input[0] =="vfh" or input[0] =="vbs" or input[0] =="vs" or input[0] =="vv"): enter =1
    if (input[0] =="PFH" or input[0] =="PBS" or input[0] =="PS" or input[0] =="PV"): enter =1
    if enter==1:
        if input[0] =="vfh" or input[0] =="PFH": 
            s='../firmware_amc13/AMC13T2Header.mcs'
            offset=0x0
        if input[0] =="vbs"or input[0] =="PBS": 
            s='../firmware_amc13/AMC13T2Golden.mcs'
            offset=0x100000
        if input[0] =="vs" or input[0] =="PS": 
            s='../firmware_amc13/AMC13T2v6.mcs'
            offset=0x200000
        if input[0] =="vv" or input[0] =="PV": 
            s='../firmware_amc13/AMC13T1v3.mcs'
            offset=0x400000
        d={}
        q=fillDataDict(d,s)
        n=len(d)
        npages=n/256
        remainder=n%256
        if remainder !=0: npages +=1
        zerosneeded=256-remainder
        if(zerosneeded != 0):
            for i in xrange(zerosneeded): d[n+i]=0
        print "\nfirmware file", s, "has", hex(n), "data bytes  (",npages," pages)"
        if input[0] =="vfh" or input[0] =="vbs" or input[0] =="vs" or input[0] =="vv": verifyflash(npages,offset,d)
        if input[0] =="PFH" or input[0] =="PBS" or input[0] =="PS" or input[0] =="PV": 
            print "WARNING: you are about to reprogram flash memory. Are you sure? (y)"
            yo=raw_input(">")
            if(yo=="y" or yo=="yes"): programflash(npages,offset,d)
#configure from flash
    if option =="L":
            print "WARNING: you are about to reprogram flash memory. Are you sure? (y)"
            yo=raw_input(">")
            if(yo=="y" or yo=="yes"): t2.write("ID",0x100)
#dump page of flash
    if input[0]=="rf":
        add=0
        if( len(input) > 1): add=int(input[1],16)
        x=readFlashData(add,0x100)
        j=0
        for iii in  xrange(16):
            print " %02x" % x[j],  " %02x" % x[j+1], " %02x" % x[j+2],  " %02x" % x[j+3],  " %02x" % x[j+4],  " %02x" % x[j+5], " %02x" % x[j+5],  " %02x" % x[j+7], " %02x" % x[j+8],  " %02x" % x[j+9], " %02x" % x[j+10],  " %02x" % x[j+11],  " %02x" % x[j+12],  " %02x" % x[j+13], " %02x" % x[j+14],  " %02x" % x[j+15]
            j +=16







