from PyChipsUser import *
import amc13
#import sys
flashSectorSize = (1<<18)       # sectors are 256k bytes
flashPageSize = 256
flashPagesPerSector = flashSectorSize/flashPageSize
#chipsLog.setLevel(logging.DEBUG)    # Verbose logging (see packets being sent and received)

# Read in an address table by creating an AddressTable object (Note the forward slashes, not backslashes!)
#addrTable = AddressTable("../addresstables_amc13/AMC13_AddressTable_S6_v01.txt")

# Create a ChipsBus bus to talk to your board.
# These require an address table object, an IP address and a port number
# input the last number of the address
sn = amc13.sn_safe()
t1, t2 = amc13.connect(sn)
amc13x = t2
#t1_ip, t2_ip = amc13.ip_addr(sn)
#print "Enter the last number of the IP address (192.168.1.xxx):"
#badinput = True
#while badinput==True:
#    option = input()
#    for i in xrange(255):
#        iplus1=i+1
#        if option==iplus1: badinput=False
#    if badinput==True:
#        print "not valid input, try again,must be in the range 1-255"
#have valid IP address

#strO=str(option)
#s='192.168.1.'+strO
#print s
#print "setting address"
#amc13 = ChipsBusUdp(addrTable, s, 50001)
print "AMC13 version:", hex(amc13x.read("T2_FIRM_VER"))
print "Initializing Spartan"
amc13x.write( "T2_FIRM_VER", 1)
#sys.exit(0)

def doCmd( len):
    #print "in doCmd"
    amc13x.write("FLASH_CMD", len)
    z = amc13x.read("FLASH_CMD")
    while z != 0:
        z = amc13x.read("FLASH_CMD")

# enable flash writing
def enableFlashWrite():
    #print "in enableFlashWrite"
    # enable flash writing
    amc13x.write( "FLASH_WBUF", 0x06 << 24)
    doCmd( 0)

# wait for write-in-progress =0, return number of cycles to complete
def waitForWriteDone():
    amc13x.write( "FLASH_WBUF", 0x05000000)
    doCmd( 1)
    z = amc13x.read( "FLASH_WBUF")
    n = 0
    while z & 0x01000000:
        doCmd( 1)
        z = amc13x.read( "FLASH_RBUF")
        n = n + 1
    return n
    
# erase a flash sector (sectors are 256k bytes)
def eraseFlashSector( s):
    enableFlashWrite()
    # erase sector 0
    adrs = s * flashSectorSize
    print "Erasing flash sector at address ", hex(adrs)
    amc13x.write( "FLASH_WBUF", 0xD8 << 24 | adrs)
    doCmd( 3)
    waitForWriteDone()

def getFlashID():
    amc13x.write( "FLASH_WBUF", 0x9f000000)
    doCmd( 3)
    return amc13x.read("FLASH_RBUF")

# read count bytes from adrs
def readFlashData( adrs, count):
    #print "exectuing read"
    if (count % 4) != 0:
        print "Warning... can only read multiple of 4 bytes"
        return
    words = count / 4
    amc13x.write( "FLASH_WBUF", 0x0b << 24 | adrs)
    doCmd( count+4)
    data = []

#    amc13.write("FLASH_WBUF",0x0b << 24 | 256)
#    doCmd( count+4)
#    for i in xrange(20):
#        print "%08x" % amc13.read("FLASH_RBUF",i) 
#    return data
    #block read code
    block=amc13x.blockRead("FLASH_RBUF",words)

    for i in xrange( words):
        buff = block[i]
        data.append( (buff&0xff000000) >> 24)
        data.append( (buff&0x00ff0000) >> 16)
        data.append( (buff&0x0000ff00) >>  8)
        data.append( (buff&0x000000ff) )
    return data
    
    #single read code
#    for i in xrange( words):
#        buff = amc13.read("FLASH_RBUF", i)
#        for j in xrange(4):
#            d = (buff>>24) & 0xff
#            data.append(d)
#            buff = buff << 8
#    return data
    

# program up to 256 (usually == 256) bytes in a flash page
#   adrs is starting byte address
#   count is number of bytes
def programFlashPage( adrs, count, data):
    #print "executing write"
    if (count % 4) != 0:
        print "Warning... can only program multiple of 4 bytes"
        return
    waitForWriteDone()          # let any previous write complete
    enableFlashWrite()
    amc13x.write( "FLASH_WBUF", (0x02 << 24) | adrs)
    offset = 1
    i = 0
    remain = count
    block=[]
    while remain > 0:
        buff = data[i] << 24 | data[i+1] << 16 | data[i+2] << 8 | data[i+3]
        #amc13.write( "FLASH_WBUF", buff, offset)
        i = i + 4
        block.append(buff)
        #offset = offset + 1
        remain = remain - 4
    amc13x.blockWrite("FLASH_WBUF",block,offset)
    doCmd( count+3)
