"""
James Rohlf
Updated by Charlie Hill
05/17/2012
"""

from flashlib_v20 import *
import os
import sys

"""options:
program flash
    Spartan
    Virtex
zero flash
    Spartan
    Virtex
read and verify flash
    Spartan
    Virtex
"""

fdi={}
for dirname, dirnames, filenames in os.walk('../firmware_amc13'):
    i=0
    for filename in filenames:
        #print os.path.join(dirname,filename)
        fdi[i]=filename
        i +=1
#print "The following firmware files were found in firmware_amc13:"
nf=len(fdi)
#for i in xrange(nf): print i, fdi[i]
#print fdi
#open(s,'r')

n=len(fdi)
type={}
for i in xrange(n):
    type[i]='unknown'
    if 'T1' in fdi[i]:
        #print "found T1", fdi[i]
        type[i]='Virtex'
    if 'T2' in fdi[i] and not 'Header' in fdi[i] and not 'Golden' in fdi[i]:
        #print "found T2", fdi[i]
        type[i]='Spartan'
    if 'Header' in fdi[i]:
        type[i]='Header'
    if 'Golden' in fdi[i]:
        type[i]='Golden'
#print type

lengths={}
pad={}
print "The following firmware files were found in firmware_amc13:"
nf=len(fdi)
for i in xrange(nf):
    lengths[i] = len(fdi[i])
#maxlen = max(lengths)
for i in xrange(nf):
    print i, fdi[i], " "*(20 - lengths[i] + 1), type[i]

print "Enter an integer for one of the following options:"
print "0  zero Spartan"
print "1  zero Virtex"
print "2  read/verify Spartan"
print "3  read/verify Virtex"
print "4  program Spartan (includes zero and read/verify)"
print "5  program Virtex  (includes zero and read/verify)"
print "6  read/verify Header"
print "7  read/verify Golden"
print "8  program Header (includes zero and read/verify)"
print "9  program Golden (includes zero and read/verify)"
strS="Choose a Spartan file (enter number):"
strV="Choose a Virtex file (enter number):"
strH="Choose a Header file (enter number):"
strG="Choose a Golden file (enter number):"

badinput = True
while badinput==True:
    option = input()
    for i in xrange(10):
        if option==i: badinput=False
    if badinput==True:
        print "not valid input, try again"

#option must be 0,1,2,3,4, or 5

#T2 section
if option==0 or option==2 or option==4 or option==6 or option==7 or option==8 or option==9:
    if option==0 or option==2 or option==4:
        add_offset=0x200000
        print strS
        for i in xrange(n):
            if type[i]=='Spartan':
                print i, fdi[i]
    if option==6 or option==8:
        add_offset=0x0
        print strH
        for i in xrange(n):
            if type[i]=='Header':
                print i, fdi[i]
    if option==7 or option==9:
        add_offset=0x100000
        print strG
        for i in xrange(n):
            if type[i]=='Golden':
                print i, fdi[i]
    while 1:            
        file=input()
        if file >= n:
            print "File selected not in list. Try again."
        elif file >=0 and file <=n:
            if (type[file] != 'Spartan' and type[file] != 'Header' and type[file] != 'Golden'):
                print "File selected not a T2 file. Try again."
            else:
                print "you have selected T2 firmware file", fdi[file]
                s='../firmware_amc13/'+fdi[file]
                break

#T1 section    
if option==1 or option==3 or option==5:
    add_offset=0x400000
    print strV
    for i in xrange(n):
        if type[i]=='Virtex':
            print i, fdi[i]
    while 1:
        file=input()
        if file >= n:
            print "File selected not in list. Try again."
        if file >=0 and file <=n:
            if type[file] != 'Virtex':
                print "File selected not a T1 file. Try again."
            else:
                print "you have selected T1 firmware file", fdi[file]
                s='../firmware_amc13/'+fdi[file]
                break
        
#parsing the mcs file
d={}
q=fillDataDict(d,s)
#get number of data bytes
n=len(d)
#get number of firmware pages
npages=n/256
#pad dictionary with zeros to fill the last page
remainder=n%256
if remainder !=0:
   npages +=1
   zerosneeded=256-remainder
   if(zerosneeded != 0):
     for i in xrange(zerosneeded): d[n+i]=0
print "\nfirmware file", s, "has", hex(n), "data bytes  (",npages," pages)"

#zero the flash
if option==0 or option==1 or option==4 or option==5 or option==8 or option==9:
    zeroflash(npages,add_offset)

#program the flash
if option==4 or option==5 or option==8 or option==9:
    programflash(npages,add_offset,d)

#read and verify the flash
if option==2 or option==3 or option==4 or option==5 or option==6 or option==8 or option==7 or option==9:
    verifyflash(npages,add_offset,d)
